
# Andover.Net adsystem per-site configuration file.
#
# This is basically a configuration file that controls the backend of the
# ad rotation system (CGI scripts and cron scripts). 
#
# Modified:  Kurt Gray -- Fri Mar 10 11:04:07 2000


# Set the siteid here -- conditions in this file should take care of the rest for you


    $siteid = 'ex000en';	# This siteid is a unique ID tag for this web site (make it different for each web site to keep your ad stats unique for each site)

    $debugging = 0;		# Setting this to 1 will cause perl scripts to dump settings info


# Global settings for all ad system scripts (things I wouldn't put in CVS)

    $adpasswd ||= 'CHANGETHIS';	 # <-- ad_admin.cgi password (make it 8 or less alphnumeric characters, no spaces)
    $mainmenu ||= '/cgi-bin/ad_admin.cgi';
    $mod_date = '06.01.2000';    


# Adjust for any per-site or per-server funkiness here
# Read the comments toward end of this file to see what each setting is for.
    
    if ( $siteid eq 'ex000en' ) {
    
	$gif_filepath = '../htdocs/banner/';
	$datfilepath = '.';
	$weblogpath = '../logs';
	@positions_list = ( 1, 2, 3, 4, 5 );
	$bannerpath = '/';
	$adinfolite = 'ad_info_lite.dat';
        $clickscript = 'ad_click.cgi';
	$clicklimit = 'none';
	$weblogfile = "$weblogpath/access_log";
	$previous_weblogfile = "$weblogpath/access_log.0";
	
    }
        

# Default options for ad_allocedit.cgi

    $can_run_megabanners ||= 'Y';		# Don't allow user to run select a megabanner if siet can't run them
    $verify_gifs_exists ||= 'Y';		# Spit out errors if ad in ad_info.dat does not have a local GIF file
    $gif_filepath ||= "../htdocs/banner/";	# Path to verify local GIFs for each ad in adInfo.dat
    $force_login ||= 'Y';			# Force a username and password to access this script
    $datfilepath ||= '.';			# Path to local ad_info.dat and ad_x_alloc.dat files
    $weblogpath ||= '../logs';


# Default options for ad_reservationsedit.cgi

    if ( ! $positions_list[0] ) {
	@positions_list = (1, 2, 3, 4, 5);		# List of which ad positions are availale on this site
    }
    
    $maxreservedpages ||= 100;			# Performance limit on how many page can be reserved


# Options for ad_rotateset.pl
 	
    $bannerpath ||= '/banner/';			# Pattern for finding ad impressions in access_log
    $clickscript ||= 'ad_click.cgi';		# Pattern for finding ad clicks in access_log
    $clicklimit ||= 50;				# How many ad clicks we'll tolerate before blocking IP in .htaccess
	
    $weblogfile ||= "$weblogpath/access_log";		# Full path name of web server access_log
    $previous_weblogfile ||= "$weblogpath/access_log2";	# Full path name of yesterday's web server access_log

    $adinfolite ||= 'ad_info2.dat';		# Name of the lean/mean ad_info.dat file


sub DumpAdConfig {

    $adpositions = join ', ', @positions_list;
    
    print "Content-type: text/plain\n\n";
    print <<AD_CONFIG_DUMP;

    Debug dump for $0:
    
	\$siteid = $siteid
	
	\$can_run_megabanners 	= '$can_run_megabanners'
	\$gif_filepath 		= '$gif_filepath'
	\$datfilepath 		= '$datfilepath'
	\$weblogpath 		= '$weblogpath'
	\@positions_list 	= \( $adpositions \)
	\$bannerpath 		= '$bannerpath'
	\$adinfolite 		= '$adinfolite'
        \$clickscript 		= '$clickscript'
	\$clicklimit 		= '$clicklimit'
	\$weblogfile 		= '$weblogfile'
	\$previous_weblogfile 	= '$previous_weblogfile'
	\$htdocs_path 		= '$htdocs_path'
	\$errordocument_404 	= '$errordocument_404'

    ad_allocedit.cgi stuff:

	\$force_login           = '$force_login'    
	\$servername		= '$servername'
	\$adposition		= '$adposition'
	\$thisscript		= '$thisscript'
	\$allocfile		= '$allocfile'
	\$largead_position	= '$largead_position'
	\$adtype		= '$adtype'
	\$yesterday		= '$yesterday'
	\$today			= '$today'
	\$todayfullsysdate	= '$todayfullsysdate'
	\$yesterday_adlog	= '$yesterday_adlog'
	\$pagetrafficlog	= '$pagetrafficlog'	
	
    ad_rotateset.pl stuff:
    
	\$todayfullsysdate	= '$todayfullsysdate'
	\$logdate		= '$logdate'
	\$weblogfile		= '$weblogfile' 
	\$previous_weblogfile	= '$previous_weblogfile'
	\$dont_set_adrotations	= '$dont_set_adrotations'

AD_CONFIG_DUMP
    
    exit;

}


##END of lib

1;

