#!/usr/bin/perl

use FormParse;

#
# This CGI script is the interface used to 
# set the reserved pages on each web site.
#
# Notes:
#	- ad_info.dat = properties of each ad
#	- ad_x_alloc.dat = unbalanced large ad allocations
#	- ad_x_rotate.dat = final rotation list for large banner 
#			 (generated each hour by ad_rotateset.pl)
#	- surviving add list is sorted by AdID
#	- removed TABLEs to make page display faster
#	- Added 'Stop on Target' and 'Stop on Date' columns
#	- Reads and writes ad_x_alloc.dat
#	- Shows projected inventory (page impressions)
#	- Ad position set by changing adposition variable
#	- adinfo.dat changed to ad_info.dat
#	- Fixed American date input to ISO
#
#
# Modified:   Kurt -- Fri Mar 10 12:32:52 2000


require 'ad_config_lib.pl';

	&DumpAdConfig if $debugging == 1;


# Ad system settings 


	$backcolor = "#DDFFFF";
	$mod_date = "06.01.2000";
	$servername = $ENV{'SERVER_NAME'};		# example: $servername = www.davecentral.com

	$thisscript = '/cgi-bin/ad_reservationsedit.cgi';
	$allocfile = 'ad_reservations_alloc.dat';	# Name of reserved pages allocation table 


	%adtypes = ( 1, 'Premium Large',
		    2, 'Display',
		    3, 'Upper Small',
		    4, 'Bottom Small',
		    5, 'Bottom Large');




# Get CGI form inputs and check user access

	$form = new FormParse;
	$form->Parse;	
	

	print "Content-type: text/html \n\n";
	print "<HTML><HEAD><TITLE>Reserved Pages on $servername</TITLE></HEAD>\n";
	print "<BODY BGCOLOR=\"$backcolor\">\n";

	$password = $1 if $form->{'in'}->{'Password'} =~ /(\w{2,8})/;

	if (($force_login eq 'Y') && ($password ne $adpasswd)) {
		print "<BR><B>Login incorrect.</B> Please login via \
            <A HREF=\"$mainmenu\">ad system main menu page</A>. \
            </BODY></HTML>";
		exit;
	}



# Print page top

	print <<TOP_OF_PAGE;

	<FONT FACE="ARIAL,HELVETICA" SIZE=4 COLOR=RED>
	<B><I>mod_adbanners Control System v$mod_date</I></B></FONT>
	<BLOCKQUOTE>
	<FONT FACE="ARIAL,HELVETICA" SIZE=6><B>$servername Reserved Pages:</B></FONT>
	<PRE>

	<FORM METHOD="POST" ACTION="$thisscript">
<B>Delete\t   Pagename\t\tPosition\t\tAdID\t\t\tStartDate\t\tStopDate</B>
TOP_OF_PAGE


# Build a hash of all ads available in ad_info.dat

	if (open(ADINFILE, "< $datfilepath/ad_info.dat")) {

		while (<ADINFILE>) {
		chop;
			($AdID,$ht,$wh,$tt,$at,$re) = split(/\t/, $_);
			
			if ( $verfiy_gifs_exist ) {
		    	    $gif_filename = $gif_filepath . $AdID . '.gif';
			    if ( ! ( -e $gif_filename ) ) {
				    print "$gif_filename does not exist <BR>\n";
				    next;
	  		    }
			}
			
			$adids{$AdID} = $AdID;
		}
		close ADINFILE;

	} else {
		$errors .= "Can't read $datfilepath/ad_info.dat: $!";
	}


	@adids2 = (sort keys %adids);


# If there is CGI input then process input from form

	$writeincount_adl = $form->{'in'}->{'writeincount_adl'};

	if ($writeincount_adl =~ /\d/) {

		$currentwritein = 0;

		for $currentreadin (0..$maxreservedpages) {

			if ($form->{'in'}->{"Pagename_" . $currentreadin} =~ /\w+/ ) {


				next if $form->{'in'}->{'Kill_' . $currentreadin};

				$pagename = $form->{'in'}->{"Pagename_" . $currentreadin};
				$adposition = $form->{'in'}->{'Position_' . $currentreadin};
				$adid = $form->{'in'}->{'AdID_' . $currentreadin};
				$StartDate = $form->{'in'}->{'StartDate_' . $currentreadin};
				$StopDate = $form->{'in'}->{'StopDate_' . $currentreadin};

# Fix American date input to ISO
			
				$StartDate = &NiceDate2ISODate($StartDate) if $StartDate =~ /\d\/\d/;
				$StopDate = &NiceDate2ISODate($StopDate) if $StopDate =~ /\d\/\d/;

				$logdata .= "$pagename\t$adposition\t$adid\t$StartDate\t$StopDate\n";
				$currentwritein++;

				print "<INPUT TYPE=\"CHECKBOX\" NAME=\"Kill_$currentwritein\" VALUE=\"T\">	";
				print "<INPUT NAME=\"Pagename_$currentwritein\" SIZE=12 VALUE=\"$pagename\">	";
				print "<SELECT NAME=\"Position_$currentwritein\">";
				for $adpos (@positions_list) {
					print '<OPTION ';
					print "VALUE=$adpos";
					print ' SELECTED' if $adpos == $adposition;
					print '>' . $adtypes{$adpos} . "\n";
				}
				print "</SELECT>\t";

				print "<SELECT NAME=\"AdID\_$currentwritein\">";
				for $temp (@adids2) {
		 			print '<OPTION ';
		 			print 'SELECTED' if $temp eq $adid;
					print '>' . $temp . "\n";
				}
				print "</SELECT>\t";
				print "<INPUT NAME=\"StartDate_$currentwritein\" SIZE=11 VALUE=\"$StartDate\">\t";
				print "<INPUT NAME=\"StopDate_$currentwritein\" SIZE=11 VALUE=\"$StopDate\">\n";				

			}  # if pagename

		}  # for keys


# Create a new allocation file

		if (open (DATAFILE, "> $datfilepath/$allocfile")) {
			print DATAFILE $logdata;
			close DATAFILE;
		} else {
			$errors .= "Can't create $datfilepath/$allocfile : $! <BR>";
		}



# No CGI input: Read data from allocation file

	} else {

		$currentwritein = 0;

		if (open(INFILE, "< $datfilepath/$allocfile")) {
			while (<INFILE>) {
			chop;
				($pagename, $position, $AdID, $StartDate, $StopDate) = split(/\t/, $_);

				$currentwritein++;

				print "<INPUT NAME=\"Kill_$currentwritein\" TYPE=\"checkbox\" VALUE=\"T\">\t";
				print "<INPUT NAME=\"Pagename_$currentwritein\" SIZE=12 VALUE=\"$pagename\">\t";
				print "<SELECT NAME=\"Position_$currentwritein\">";
				for $adpos (@positions_list) {
		 			print '<OPTION ';		 			
					print "VALUE=$adpos";
					print ' SELECTED' if $adpos == $position;
					print '>' . $adtypes{$adpos} . "\n";
				}
				print "</SELECT>\t";

				print "<SELECT NAME=\"AdID_$currentwritein\">";
				for $temp (@adids2) {
		 			print '<OPTION ';
		 			print 'SELECTED' if $temp eq $AdID;
					print '>' . $temp . "\n";
				}
				print "</SELECT>\t";
				print "<INPUT NAME=\"StartDate_$currentwritein\" SIZE=11 VALUE=\"$StartDate\">\t";
				print "<INPUT NAME=\"StopDate_$currentwritein\" SIZE=11 VALUE=\"$StopDate\">\n";

			}  # while INFILE
			close INFILE;
		} else {
			$errors .= "Can't read $datfilepath/$allocfile : $!";
		}


	}  # endif CGI


	$writeincount_adl = $currentwritein;
	$writeincount_adl2 = $writeincount_adl + 1;
	$writeincount_adl3 = $writeincount_adl + 2;

	for $temp (@adids2) {
		$selectlist .= "<OPTION>$temp\n";
	}


	for $adpos (@positions_list) {
		$selectlist2 .= '<OPTION ';
		$selectlist2 .= "VALUE=$adpos";
		$selectlist2 .= '>' . $adtypes{$adpos} . "\n";
	}



	$errors = "<FONT COLOR=RED><H3>Errors occured during processing!</H3\>$errors</FONT>" if $errors;


# Print rest of page

	print <<BOTTOM;

$errors
<B>$writeincount_adl</B> Reserved pages on $servername


<B>New\tPagename\t\tPosition\t\tAdID\t\t\tStartDate\t\tStopDate</B>
\t<INPUT NAME="Pagename_$writeincount_adl2" SIZE=12>	<SELECT NAME="Position_$writeincount_adl2"> $selectlist2 </SELECT>	<SELECT NAME="AdID_$writeincount_adl2"> $selectlist </SELECT>\t<INPUT NAME="StartDate_$writeincount_adl2" SIZE=11>\t<INPUT NAME="StopDate_$writeincount_adl2" SIZE=11>
\t<INPUT NAME="Pagename_$writeincount_adl3" SIZE=12>	<SELECT NAME="Position_$writeincount_adl3"> $selectlist2 </SELECT>	<SELECT NAME="AdID_$writeincount_adl3"> $selectlist </SELECT>\t<INPUT NAME="StartDate_$writeincount_adl3" SIZE=11>\t<INPUT NAME="StopDate_$writeincount_adl3" SIZE=11>
</PRE>
	<INPUT TYPE="HIDDEN" NAME="writeincount_adl" VALUE="$writeincount_adl"> 
	<INPUT TYPE="HIDDEN" NAME="Password" VALUE="$password">
<INPUT TYPE="SUBMIT" VALUE="Save Changes to ad_reservations.dat on $servername">
	</FORM><FORM METHOD=POST ACTION="$mainmenu">
	<INPUT TYPE="HIDDEN" NAME="Password" VALUE="$password">
<INPUT TYPE="SUBMIT" VALUE="Return to Main Menu">
	</FORM>

	</BLOCKQUOTE>
	</BODY>
	</HTML>

BOTTOM



sub NiceDate2ISODate {

        local ($nicedate) = @_;
        ($mon,$day,$year) = split(/[\/\-]/, $nicedate);
        $day =~ s/^0//;
        $day = '0' . $day if $day < 10;
        $mon =~ s/^0//;
        %monthlist = qw/1 Jan 2 Feb 3 Mar 4 Apr 5 May 6 Jun 7 Jul 8 Aug 9 Sep 10 Oct 11 Nov 12 Dec/;
        $year = `/bin/date +%Y` unless $year =~ /\d\d\d\d/;
        $year =~ s/\W//g;
        
        return $day . '/' . $monthlist{$mon} . '/' . $year;

}  # Converts 2/03/98 to 03/Mar/1998




__END__

